#define weights vec3(2.0 / 8.0, 5.0 / 8.0, 1.0 / 8.0)
#define shift 1.0 / 255.0

precision mediump float;
uniform sampler2D tex_sampler_0;
uniform float u_floatParam;
varying vec2 v_texCoord;

vec3 rgb2hsv(vec3 c) {
    vec4 K = vec4(0.0, -1.0 / 3.0, 2.0 / 3.0, -1.0);
    vec4 p = mix(vec4(c.bg, K.wz), vec4(c.gb, K.xy), step(c.b, c.g));
    vec4 q = mix(vec4(p.xyw, c.r), vec4(c.r, p.yzx), step(p.x, c.r));
    float d = q.x - min(q.w, q.y);
    float e = 1.0e-10;
    return vec3(abs(q.z + (q.w - q.y) / (6.0 * d + e)), d / (q.x + e), q.x);
}

void main() {
    vec4 color = texture2D(tex_sampler_0, v_texCoord);
    float kv = dot(color.rgb, weights) + shift;
    vec3 new_color;
    vec3 hsv = rgb2hsv(color.rgb);

    if ( 0.5 < hsv.x && hsv.x < 0.75) {
         new_color = color.rgb;
    }
    else {
        new_color = u_floatParam * color.rgb + (1.0 - u_floatParam) * kv;
    }
    gl_FragColor = vec4(new_color, color.a);
}

